(defun c:SObjekty ()
;;; definice nov funkce kresli
  (setq	gl_pam_hodnoty		;;; globln promnn uchovvajc jednotliv nastaven
     (list
	(cons "co_kreslit"   "Kruznice")	;;; uren co se bude kreslit
	(cons "stredkex"     "0.0")		;;; x-ova souadnice stedu sost. krunic
	(cons "stredkey"     "0.0")		;;; y-ova souadnice stedu sost. krunic
	(cons "stredkez"     "0.0")		;;; z-ova souadnice stedu sost. krunic
	(cons "strednex"     "0.0")		;;; x-ova souadnice stedu sost. n-uhelnk
	(cons "stredney"     "0.0")		;;; y-ova souadnice stedu sost. n-uhelnk
	(cons "strednez"     "0.0")		;;; z-ova souadnice stedu sost. n-uhelnk
	(cons "pocvrcholune" "3")		;;; poet vrchol n - helnku (editbox)
	(cons "pocvrcholuns" "3")		;;; poet vrchol n - helnku (slider)
	(cons "polomerne"    "3")		;;; polomr n - helnku (editbox)
	(cons "polomerns"    "3")		;;; polomr n - helnku (slider)
	(cons "pocetne"      "1")		;;; poet n - helnk (editbox)
	(cons "pocetns"      "1")		;;; poet n - helnk (slider)
	(cons "vzdalenostne" "1")		;;; vzdlenost mezi n - helnky (editbox)
	(cons "vzdalenostns" "1")		;;; vzdlenost mezi n - helnky (slider)
	(cons "polomerke"    "1")		;;; polomr krunice (editbox)
	(cons "polomerks"    "1")		;;; polomr krunice (slider)
	(cons "pocetke"      "1")		;;; poet krunic (editbox)
	(cons "pocetks"      "1")		;;; poet krunic (slider)
	(cons "vzdalenostke" "1")		;;; vzdlenost mezi krunicemi (editbox)
	(cons "vzdalenostks" "1")		;;; vzdlenost mezi krunicemi (slider)
	(cons "kruz_stred_but"  "0")		;;; tlatko - stred kruznice
	(cons "nuhel_stred_but" "0")		;;; tlatko - stred n helnku
     )
  )
  (setq zadani (so:zpusob_zadani))      ;;; nastaven promnn urujc jakm
  					;;; zpsobem se maj zadat informace
  (if (= zadani "prikaz")		;;; zadn hodnot pomoc pkazovho dku
    (if	(= (so:zadej_hodnoty) T)
      (so:vykresli)			;;; vykreslen poadovanho objektu,
      					;;; v ppad e byly zadny hodnoty
    )
  )
  (if (= zadani "dialog")		;;; zadn hodnot pomoc dialogovho boxu
    (if	(= (so:dialog) T)
      (so:vykresli)			;;; vykreslen poadovanho objektu,
      					;;; v ppad e byly zadny hodnoty  
    )
  )
  (princ "Funkce c:SObjekty dokonila innost")	;;; informace o ukonen funkce
  (princ)
)

 
(defun so:dialog (/ id co_delat vysledek)
  (setq id (load_dialog "d:/vyber.dcl"))	;;; pedn jmna dialogovho boxu
    ;;; CESTU K UMSTN DIALOGU SE MUS AKTUALIZOVAT PODLE AKTUALNHO UMSTN
    
  (setq co_delat 2)
  (while (>= co_delat 2)			;;; opakuj pokud nenastane zmena
    (if	(not (new_dialog "vyber" id))		;;; nen-li jmno dialogu vyber tak skoni
      (exit)
    )
    (start_list "popup")	;;; vytvoen poloek popup listu
      (add_list "N helnk")	;;; pidn poloky "N helnk"
      (add_list "Krunice")	;;; pidn poloky "Krunice"
    (end_list)

    ;;; nastaven hodnot dialogovch prvk
    (set_tile "polomerke"    (cdr (assoc "polomerke"    gl_pam_hodnoty)))
    (set_tile "polomerks"    (cdr (assoc "polomerks"    gl_pam_hodnoty)))
    (set_tile "pocetke"      (cdr (assoc "pocetke"      gl_pam_hodnoty)))
    (set_tile "pocetks"      (cdr (assoc "pocetks"      gl_pam_hodnoty)))
    (set_tile "vzdalenostke" (cdr (assoc "vzdalenostke" gl_pam_hodnoty)))
    (set_tile "vzdalenostks" (cdr (assoc "vzdalenostks" gl_pam_hodnoty)))
    (set_tile "polomerne"    (cdr (assoc "polomerne"    gl_pam_hodnoty)))
    (set_tile "polomerns"    (cdr (assoc "polomerns"    gl_pam_hodnoty)))
    (set_tile "pocetne"      (cdr (assoc "pocetne"      gl_pam_hodnoty)))
    (set_tile "pocetns"      (cdr (assoc "pocetns"      gl_pam_hodnoty)))
    (set_tile "vzdalenostne" (cdr (assoc "vzdalenostne" gl_pam_hodnoty)))
    (set_tile "vzdalenostns" (cdr (assoc "vzdalenostns" gl_pam_hodnoty)))
    (set_tile "pocvrcholune" (cdr (assoc "pocvrcholune" gl_pam_hodnoty)))
    (set_tile "pocvrcholuns" (cdr (assoc "pocvrcholuns" gl_pam_hodnoty)))
    (set_tile "stredkex"     (cdr (assoc "stredkex"     gl_pam_hodnoty)))
    (set_tile "stredkey"     (cdr (assoc "stredkey"     gl_pam_hodnoty)))
    (set_tile "stredkez"     (cdr (assoc "stredkez"     gl_pam_hodnoty)))
    (set_tile "strednex"     (cdr (assoc "strednex"     gl_pam_hodnoty)))
    (set_tile "stredney"     (cdr (assoc "stredney"     gl_pam_hodnoty)))
    (set_tile "strednez"     (cdr (assoc "strednez"     gl_pam_hodnoty)))

    (action_tile "kruznice" "(so:naskruh)")
		;;; je-li vybrn radio_button "kruznice" zavolej funkci (so:naskruh)
    (action_tile "nuhelnik" "(so:nasnuhe)")
		;;; je-li vybrn radio_button "nuhelnik" zavolej funkci (so:nasnuhe)
    (action_tile "popup"
      "(progn
         (if (= $value \"0\")(so:nasnuhe))			
         (if (= $value \"1\") (so:naskruh))
	)"
    )
		;;; je-li vybrna poloka popup_listu "N helnk" zavolej funkci (so:nasnuhe)
		;;; je-li vybrna poloka popup_listu "Krunice" zavolej funkci (so:naskruh)
    (action_tile "polomerks" "(so:vazba_prvku $value $reason \"polomerke\"  \"polomerks\")")
    (action_tile "pocetks"   "(so:vazba_prvku $value $reason \"pocetke\"    \"pocetks\")")
    (action_tile "vzdalenostks"	"(so:vazba_prvku $value $reason \"vzdalenostke\" \"vzdalenostks\")")
    (action_tile "polomerns" "(so:vazba_prvku $value $reason \"polomerne\"  \"polomerns\")")
    (action_tile "pocetns"   "(so:vazba_prvku $value $reason \"pocetne\"    \"pocetns\")")
    (action_tile "vzdalenostns"	"(so:vazba_prvku $value $reason \"vzdalenostne\" \"vzdalenostns\")")
    (action_tile "pocvrcholuns"	"(so:vazba_prvku $value $reason \"pocvrcholune\" \"pocvrcholuns\")")
		;;; je-li zmnn nkter posuvnk "slider.." zavolej funkci so:vazba_prvk
    (action_tile "stredkex"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkex\" $value)
          (assoc \"stredkex\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredkey"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkey\" $value)
          (assoc \"stredkey\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredkez"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredkez\" $value)
          (assoc \"stredkez\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox stedu krunice nastav odpovdajc hodnoty
    (action_tile "polomerke" "(so:vazba_prvku $value $reason \"polomerke\" \"polomerks\")")
    (action_tile "pocetke"
      		 "(so:vazba_prvku (zaokr_string $value) $reason \"pocetke\" \"pocetks\")"
    )
    (action_tile "vzdalenostke"	"(so:vazba_prvku $value $reason \"vzdalenostke\" \"vzdalenostks\")")
		;;; je-li zmnn nkter editbox zavolej funkci so:vazba_prvku
    (action_tile "strednex"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"strednex\" $value)
          (assoc \"strednex\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "stredney"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"stredney\" $value)
          (assoc \"stredney\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
    (action_tile "strednez"
       "(setq gl_pam_hodnoty
        (subst
          (cons \"strednez\" $value)
          (assoc \"strednez\" gl_pam_hodnoty)
          gl_pam_hodnoty
        ))"
    )
		;;; je-li zmnn nkter editbox stedu n-helnku nastav odpovdajc hodnoty
    (action_tile "polomerne" "(so:vazba_prvku $value $reason \"pocvrcholune\" \"polomerns\")")
    (action_tile "pocetne"
      		 "(so:vazba_prvku (zaokr_string $value) $reason \"pocetne\" \"pocetns\")")
    (action_tile "vzdalenostne"	"(so:vazba_prvku $value $reason \"vzdalenostne\" \"vzdalenostns\")")
    (action_tile "pocvrcholune"
		 "(so:vazba_prvku (zaokr_string $value) $reason \"pocvrcholune\" \"pocvrcholuns\")")
		;;; je-li zmnn nkter editbox zavolej funkci so:vazba_prvku
    		;;; pozor hodnota $value je u nkterch prvk zaokrouhlena
    (action_tile "kruz_stred_but" "(done_dialog 4)")
		;;; je-li zmknuto tlatko "kruz_stred_but" zavolej
    		;;; funkci done_dialog s hodnotou 4
    (action_tile "nuhel_stred_but" "(done_dialog 4)")
		;;; je-li zmknuto tlatko "nuhel_stred_but" zavolej
    		;;; funkci done_dialog s hodnotou 4
    (action_tile "accept" "(done_dialog 1)")
		;;; je-li zmknuto tlatko "accept"
    		;;; zavolej funkci done_dialog s hodnotou 1
    (action_tile "cancel" "(done_dialog 0)")
		;;; je-li zmknuto tlatko "cancel"
    		;;; zavolej funkci done_dialog s hodnotou 0
    (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "Kruznice")
			;;; je-li nastaveno kresleni kruznice
      (so:naskruh)	;;; zavolej fukci (so:naskruh)
    )
    (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "N-uhelnik")
			;;; nen-li nastaveno kresleni n-helnku
      (so:nasnuhe)	;;; zavolej funkci (so:nasnuhe)
    )
    (setq co_delat (start_dialog))
		;;; nastav promnnou na hodnotu zskanou od funkce start_dialog
		;;; (hodnota s kterou kon funkce done_dialog)
    (cond	;;; uren dal innosti
      ((= co_delat 0) (setq vysledek nil))	;;; uivatel stornoval dialog = konec funce
      ((= co_delat 1) (setq vysledek T))	;;; uivatel potvrdil dialog,
      						;;; zavolej funkci (vykresli)
      ((= co_delat 4) (so:nastav_stred (getpoint "\nVbr bodu:")))
				;;; uivatel zmkl tlatko pro zadn souadnic stedu
	    			;; zavolej funkci nastav_sted
    )
  )
  (unload_dialog id)		;;; odstran dialog id z pamti
    vysledek			;;; vrcen vsledku funkce (jestli probhla OK)
)


(defun so:naskruh ()
;;; nastaven hodnot (pepna) a viditelnosti prvk pro   nabdku krunice
  (setq gl_pam_hodnoty 
    (subst
      (cons "co_kreslit" "Kruznice")
      (assoc "co_kreslit" gl_pam_hodnoty)
      gl_pam_hodnoty
    )
  )			;;; nastaven aktulnho objeku v asoc. seznamu na hodnotu "Kruznice"

  (set_tile "kruznice" "1")	;;; nastaven radio_buttunu "kruznice" jako zvraznn
  (set_tile "nuhelnik" "0")	;;; nastaven radio_buttunu "n uhelnik" jako nezvraznn
  (set_tile "popup"    "1")	;;; nastaven popup_listu na hodnotu "Krunice"

;;; deaktivovn prvk   pslunch k n-helnku:
  (mode_tile "strednex"     1)	;;; deaktivovn edit_boxu "strednex"
  (mode_tile "stredney"     1)	;;; deaktivovn edit_boxu "stredney"
  (mode_tile "strednez"     1)	;;; deaktivovn edit_boxu "strednez"
  (mode_tile "polomerne"    1)	;;; deaktivovn edit_boxu "polomerne"
  (mode_tile "pocetne"      1)	;;; deaktivovn edit_boxu "pocetne"
  (mode_tile "vzdalenostne" 1)	;;; deaktivovn edit_boxu "vzdalenostne" 
  (mode_tile "pocvrcholune" 1)	;;; deaktivovn edit_boxu "pocvrcholune"
  (mode_tile "polomerns"    1)	;;; deaktivovn slideru "polomerns"
  (mode_tile "pocetns"      1)	;;; deaktivovn slideru "pocetns" 
  (mode_tile "vzdalenostns" 1)	;;; deaktivovn slideru "vzdalenostns" 
  (mode_tile "pocvrcholuns" 1)	;;; deaktivovn slideru "pocvrcholuns"
  (mode_tile "nuhel_stred_but" 1)	;;; deaktivovn tlatka "nuhel_stred_but" 
;;; aktivovn   prvk pslunch ke krunici:
  (mode_tile "polomerks"    0)	;;; aktivovn slideru "polomerks"
  (mode_tile "pocetks"     0)	;;; aktivovn slideru "pocetks"
  (mode_tile "vzdalenostks" 0)	;;; aktivovn slideru "vzdalenostks" 
  (mode_tile "stredkex"    0)	;;; aktivovn edit_boxu "stredkex"
  (mode_tile "stredkey"    0)	;;; aktivovn edit_boxu "stredkey" 
  (mode_tile "stredkez"     0)	;;; aktivovn edit_boxu "stredkez"
  (mode_tile "polomerke"    0)	;;; aktivovn edit_boxuu "polomerke"
  (mode_tile "pocetke"      0)	;;; aktivovn edit_boxu "pocetke" 
  (mode_tile "vzdalenostke" 0)	;;; aktivovn edit_boxu "vzdalenostke"
  (mode_tile "kruz_stred_but" 0)	;;; aktivovn tlatka "kruz_stred_but"
)
  


(defun so:nasnuhe ()
;;; nastaven hodnot (pepna) a viditelnosti prvk pro   nabdku n-helnk
  (setq gl_pam_hodnoty 
    (subst
      (cons "co_kreslit" "N-uhelnik")
      (assoc "co_kreslit" gl_pam_hodnoty)
      gl_pam_hodnoty
    )
  )		;;; nastaven aktulnho objeku v asoc. seznamu na hodnotu "Kruznice"
  
  (set_tile "kruznice" "0")	;;; nastaven radio_buttunu "kruznice" jako nezvraznn
  (set_tile "nuhelnik" "1")	;;; nastaven radio_buttunu "n uhelnik" jako zvraznn
  (set_tile "popup"    "0")	;;; nastaven popup_listu na hodnotu "N - helnk"

;;; deaktivovn prvk   pslunch ke krunici:
  (mode_tile "polomerks"    1)	;;; deaktivovn slideru "polomerks"
  (mode_tile "pocetks"      1)	;;; deaktivovn slideru "pocetks"
  (mode_tile "vzdalenostks" 1)	;;; deaktivovn slideru "vzdalenostks" 
  (mode_tile "stredkex"     1)	;;; deaktivovn edit_boxu "stredkex"
  (mode_tile "stredkey"     1)	;;; deaktivovn edit_boxu "stredkey" 
  (mode_tile "stredkez"     1)	;;; deaktivovn edit_boxu "stredkez"
  (mode_tile "polomerke"    1)	;;; deaktivovn edit_boxuu "polomerke"
  (mode_tile "pocetke"      1)	;;; deaktivovn edit_boxu "pocetke" 
  (mode_tile "vzdalenostke" 1)	;;; deaktivovn edit_boxu "vzdalenostke"
  (mode_tile "kruz_stred_but" 1)	;;; deaktivovn tlatka "kruz_stred_but"
;;; aktivovn prvk pslunch   k n-helnku:
  (mode_tile "strednex"     0)	;;; aktivovn edit_boxu "strednex"
  (mode_tile "stredney"     0)	;;; aktivovn edit_boxu "stredney"
  (mode_tile "strednez"     0)	;;; aktivovn edit_boxu "strednez"
  (mode_tile "polomerne"    0)	;;; aktivovn edit_boxu "polomerne"
  (mode_tile "pocetne"      0)	;;; aktivovn edit_boxu "pocetne"
  (mode_tile "vzdalenostne" 0)	;;; aktivovn edit_boxu "vzdalenostne" 
  (mode_tile "pocvrcholune" 0)	;;; aktivovn edit_boxu "pocvrcholune"
  (mode_tile "polomerns"    0)	;;; aktivovn slideru "polomerns"
  (mode_tile "pocetns"      0)	;;; aktivovn slideru "pocetns" 
  (mode_tile "vzdalenostns" 0)	;;; aktivovn slideru "vzdalenostns" 
  (mode_tile "pocvrcholuns" 0)	;;; aktivovn slideru "pocvrcholuns"
  (mode_tile "nuhel_stred_but" 0)	;;; aktivovn tlatka "nuhel_stred_but" 
)

(defun zaokr_string (string)
;;; funkce pro pevod etzce reprezentujcho   reln slo
;;; na etzec reprezentujc cel slo
  (setq str (atoi string))			;;; pevede etzec na cel slo
  (setq string (vl-princ-to-string str))	;;; pevede slo na etzec
)


(defun so:zpusob_zadani	(/ vysledek)	;;; funkce vrac etzec urujc zpsob zadn hodnot
  (initget "D P _dialog prikaz")	;;; uren monch vstupnch hodnot
  (setq	vysledek
    (getkword "Jakm zpsobem si pejete zadat hodnoty (Dialog / Pkazov_ dek)? :")
  )					;;; zskn klovho slova pro pokraovn
  vysledek				;;; pedn nvratov hodnoty nadazen funkci
)

(defun so:zadej_hodnoty	(/ vysledek)	;;; funkce pro zadn hodnot
  (setq vysledek nil)
  (initget "K N _Kruznice N-uhelnik ")	;;; uren monch vstupnch hodnot
  (setq	co_kreslit
    (getkword "Jak objekty mm kreslit (Krunice / N helnk)? :")
  )					;;; zskn klovho slova pro pokraovn
  (setq	gl_pam_hodnoty
    (subst
       (cons  "co_kreslit" co_kreslit)
       (assoc "co_kreslit" gl_pam_hodnoty)
       gl_pam_hodnoty
    )
  )

  (so:nastav_stred (getpoint "\nZadej sted obrazce: "))
  
  (if (= co_kreslit "Kruznice")		;;; uivatel poaduje kreslit krunici
    (progn
      (initget 1)	;;; kontrola zadn seln hodnoty ( 0 potvrzen zadn je ENTREM)
      (setq polomerk (getreal "\n Zadej polomr krunice: "))
      			;;; zjistn hodnoty polomru
      (setq gl_pam_hodnoty
        (subst
	  (cons  "polomerke" (vl-princ-to-string polomerk))
 	  (assoc "polomerke" gl_pam_hodnoty)
	  gl_pam_hodnoty
        )
      )			;;; uloen hodnoty polomru krunice do asoc. seznamu gl_pam_hodnoty

      (initget 1)	;;; kontrola zadn seln hodnoty ( 0 potvrzen zadn je ENTREM)
      (setq pocetk (getint "\n Zadej poet nakreslench krunic: "))
			;;; zadn potu kreslench krunic
      (setq gl_pam_hodnoty
        (subst
	  (cons  "pocetke" (itoa pocetk))
	  (assoc "pocetke" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen potu krunic z promnn pocetk
      			;;; do asoc. seznamu gl_pam_hodnoty

      (initget 1)	;;; kontrola zadn seln hodnoty ( 0 potvrzen zadn je ENTREM)
      (setq vzdalenostk (getreal "\n Zadej vzdlenost mezi krunicemi: "))
			;;; zadn vzdlenosti mezi krunicemi
      (setq gl_pam_hodnoty
        (subst
	  (cons  "vzdalenostke" (vl-princ-to-string vzdalenostk))
	  (assoc "vzdalenostke" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen vzdlenosti mezi krunicemi z promnn
      			;;; vzdalenostk do asoc. seznamu gl_pam_hodnoty
    (setq vysledek T)
    )    
  )
  
  (if (= co_kreslit "N-uhelnik")	;;; uivatel poaduje kreslit n-helnk
    (progn
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq pocvrcholun (getint "\n Zadej poet vrchol n-helnku: "))
			;;; zadn poetu vrchol n-helnku
      (setq gl_pam_hodnoty
	(subst
	  (cons  "pocvrcholune" (itoa pocvrcholun))
	  (assoc "pocvrcholune" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen potu vrchol z promnn pocvrcholun
      			;;; do asoc. seznamu gl_pam_hodnoty
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq polomern (getreal "\n Zadej polomr opsan krunice n-helnku: "))
			;;; zadn hodnoty polomru prvn vepsan krunice
      (setq gl_pam_hodnoty
	(subst
	  (cons  "polomerne" (vl-princ-to-string polomern))
	  (assoc "polomerne" gl_pam_hodnoty)
      	  gl_pam_hodnoty
        )
      )			;;; uloen polomru prvn vepsan krunice z promnn
	    		;;; polomern do asoc. seznamu gl_pam_hodnoty
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq pocetn (getint "\n Zadej poet n-helnk: "))
			;;; zadn hodnoty poetu kreslench n-helnk
      (setq gl_pam_hodnoty
	(subst
	  (cons  "pocetne" (itoa pocetn))
	  (assoc "pocetne" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )			;;; uloen potu kreslench n-helnk z promnn pocetne
      			;;; do asoc. seznamu gl_pam_hodnoty
      (initget 7)	;;; kontrola zadn seln hodnoty (zakaz zadn
      			;;; zporn hodnoty a 0), potvrzen zadn je ENTREM
      (setq vzdalenostn (getreal "\n Zadej vzdlenost mezi n-helnky: "))
			;;; zadn vzdlenosti mezi n-helnky
      (setq gl_pam_hodnoty
	(subst
	  (cons  "vzdalenostne" (vl-princ-to-string vzdalenostn)) 
          (assoc "vzdalenostne" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )			;;; uloen vzdlenosti mezi n-helnky z promnn vzdalenostne
      			;;; do asoc. seznamu gl_pam_hodnoty

      (if (< pocvrcholun 3)	;;; oeten chybnho zadn
        (progn
          (princ "\n Zvtil jsem poet vrchol n-helnku na minimln poet 3")
          (setq gl_pam_hodnoty
	    (subst
	      (cons "pocvrcholune" "3")
	      (assoc "pocvrcholune" gl_pam_hodnoty)
	      gl_pam_hodnoty
	    )
          )		;;; oprava hodnoty v promnn gl_pam_hodnoty
        )
      )			;;; oeten chybnho zadn

      (if (< polomerne 30)	;;; oeten chybnho zadn
	(progn
  	  (princ "\n Zvtil jsem polomr n-helnku poet 30")
  	  (setq	gl_pam_hodnoty
	    (subst
	      (cons "polomerne" "30")
	      (assoc "polomerne" gl_pam_hodnoty)
	      gl_pam_hodnoty
	    )
          )		;;; oprava hodnoty v promnn gl_pam_hodnoty
	)
      )
      (setq vysledek T)
    )
  )
  vysledek
)

(defun so:vykresli (/ co_kreslit)
  (setq co_kreslit (cdr (assoc "co_kreslit" gl_pam_hodnoty)))
  	;;; zskn klovho slova pro uren dalho postupu pokraovn
  (if (= co_kreslit "Kruznice")		;;; uivatel poaduje kreslit krunici
    (so:kresli_kruznici)		;;; voln funkce pro vykreslen krunice
  )
  (if (= co_kreslit "N-uhelnik")	;;; uivatel poaduje kreslit n-helnk
    (so:kresli_nuhelnik)		;;; voln funkce pro vykreslen n-helnku
  )
)

(defun so:nastav_stred (stred / stredx stredy stredz)
;;; funkce pro nastaven hodnot souadnic stedu do globln promnn gl_pam_hodnoty
  (setq stredx (strcat (vl-princ-to-string (car stred))))
  (setq stredy (strcat (vl-princ-to-string (cadr stred))))
  (setq stredz (strcat (vl-princ-to-string (caddr stred))))
  (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "Kruznice")	;;; jak sted se nastavuje
    (progn							;;; nastavujeme sted krunice
      (setq gl_pam_hodnoty
        (subst
	  (cons  "stredkex" stredx)
          (assoc "stredkex" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
        (subst
	  (cons  "stredkey" stredy)
          (assoc "stredkey" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
	(subst
	  (cons  "stredkez" stredz)
	  (assoc "stredkez" gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
    )
  )
  (if (= (cdr (assoc "co_kreslit" gl_pam_hodnoty)) "N-uhelnik")	;;; jak sted se nastavuje
    (progn							;;; nastavujeme sted "N-uhelnik"
      (setq gl_pam_hodnoty
        (subst
   	  (cons  "strednex" stredx)
          (assoc "strednex" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )
      (setq gl_pam_hodnoty
        (subst 
	  (cons  "stredney" stredy)
          (assoc "stredney" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )
      (setq gl_pam_hodnoty
        (subst
	  (cons  "strednez" stredz)
          (assoc "strednez" gl_pam_hodnoty)
          gl_pam_hodnoty
        )
      )
    )
  )
)

(defun so:kresli_nuhelnik (/ stred_nu pocvrcholu polomer pol_kresl	pocet vzdalenost)
;;; vykreslen n-helnku
;;;; stred_nu   - souadnice stedu (real.slo, real.slo, real.slo)
;;;; pocvrcholu - cel slo reprezentujc poet vrchol n-helnku
;;;; polomer    - real.slo reprezentujc polomr prvn vepsan krunice
;;;; pol_kresl  - real.slo reprezentujc polomr vepsanch krunic
;;;; pocet      - cel slo reprezentujc poet kreslench soustednch n-helnk
;;;; vzdalenost - real.slo reprezentujc vzdlenost mezi n-helnky
  (setq	stred_nu
    (list
      (atof (cdr (assoc "strednex" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredney" gl_pam_hodnoty)))
      (atof (cdr (assoc "strednez" gl_pam_hodnoty)))
    )
  )		;;; pevod t etzc reprezentujcch souadnice
  		;;; do promnn stred (poloky stred jsou typu float)
  (setq pocvrcholu (atoi (cdr (assoc "pocvrcholune" gl_pam_hodnoty))))
		;;; zskn potu vrchol n-helnku z asoc. seznamu gl_pam_hodnoty
  (setq polomer    (atof (cdr (assoc "polomerne"    gl_pam_hodnoty))))
		;;; zskn polomru prvn vepsan krunice z asoc. seznamu gl_pam_hodnoty
  (setq pocet      (atoi (cdr (assoc "pocetne"      gl_pam_hodnoty))))
		;;; zskn poetu kreslench n-helnk z asoc. seznamu gl_pam_hodnoty
  (setq vzdalenost (atof (cdr (assoc "vzdalenostne" gl_pam_hodnoty))))
		;;; zskn vzdlenosti mezi n-helnky z asoc. seznamu gl_pam_hodnoty

  (while (> pocet 0)	;;; dokud je co kreslit opakuj
    (setq pol_kresl (+ polomer (* vzdalenost (- pocet 1))))
		;;; nastaven aktulnho polomru vepsan krunice, kreslenho n-uhelnku
    (command)	;;; ukonen vech pedchozch pkaz
    (command "_polygon" pocvrcholu stred_nu "O" pol_kresl)
    		;;; vykresli n-helnku
    (setq pocet (- pocet 1))	;;; zmeni poet n-helnk o 1
  )
)

(defun so:kresli_kruznici (/ stred_kr polomer pol_kresl pocet vzdalenost)
;;; vykreslen krunice
;;;; stred_kr - souadnice stedu (real.slo, real.slo, real.slo)
;;;; polomer - real.slo reprezentujc polomr prvn krunice
;;;; pol_kresl - real.slo reprezentujc polomr vykreslovan krunice
;;;; pocet - cel slo reprezentujc poet kreslench soustednch krunic
;;;; vzdalenost - real.slo reprezentujc vzdlenost mezi krunicemi
  (setq stred_kr
    (list
      (atof (cdr (assoc "stredkex" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredkey" gl_pam_hodnoty)))
      (atof (cdr (assoc "stredkez" gl_pam_hodnoty)))
    )
  )		;;; pevod t etzc reprezentujcch souadnice
  		;;; do promnn stred (poloky stred jsou typu float)
  (setq polomer (atof (cdr (assoc "polomerke" gl_pam_hodnoty))))
		;;; zskn polomru prvn krunice z asoc. seznamu gl_pam_hodnoty
  (setq pocet (atoi (cdr (assoc "pocetke" gl_pam_hodnoty))))
		;;; zskn potu kreslench krunic z asoc. seznamu gl_pam_hodnoty
  (setq vzdalenost (atof (cdr (assoc "vzdalenostke" gl_pam_hodnoty))))
		;;; zskn vzdlenosti mezi krunicemi z asoc. seznamu gl_pam_hodnoty
  (command)	;;; ukonen vech pedchozch pkaz
  (while (> pocet 0)	;;; dokud je co kreslit opakuj
    (setq pol_kresl (+ polomer (* vzdalenost (- pocet 1))))	;;; nastav aktuln polomr
    (command "_circle" stred_kr pol_kresl)
  		;;; vykreslen krunice
    (setq pocet (- pocet 1))					;;; zmeni poet krunic o 1
  )
)

(defun so:vazba_prvku (val why editbox slider)
;;; funkce pro nastaven odpovdajcch prvk na stejn hodnoty
;;; pklad editbox1 a slider1 atd.
;;; val - nastavovan hodnota
;;; why - uruje jak akce uivatele vyvolala akci dialogovho   prvku
;;; editbox - jmno prvku typu editbox
;;; slider - jmno odpovdajcho prvku typu slider

  (if (or (= why 2) (= why 1))
;;; zjisten jak akce uivatele zpsobila akci dialogu
;;; 2 = opustn editboxu
;;; 1 = uivatel vybral prvek (pklad entrem)
    (progn
      (setq edit_hodnota (atof val))
;;; peveden etzce reprezentujcho nastavenou hodnotu   na slo
      (if (> edit_hodnota 100)
	(setq val "100")	;;; je-li slo mimo rozsah prvku, prove korekci
      )
      (if (< edit_hodnota 0)
	(setq val "0")		;;; je-li slo mimo rozsah prvku, prove korekci
      )
      (if (and (= editbox "pocvrcholune") (< edit_hodnota 3))
	(setq val "3")		;;; kontrola jestli nezadvme poet vrchol n-helnku <   3
      )
      (if (and (= editbox "polomerne") (< edit_hodnota 30))
	(setq val "30")	;;; kontrola jestli nezadvme polomr opsan krunice n-helnku   < 3
      )
      (set_tile editbox val)	;;; nastaven editboxu na sprvnou hodnotu
      (set_tile slider val)	;;; nastaven slideru na sprvnou hodnotu
      (setq gl_pam_hodnoty
	(subst
	  (cons editbox val)
	  (assoc editbox gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
      (setq gl_pam_hodnoty
	(subst
	  (cons slider val)
	  (assoc slider gl_pam_hodnoty)
	  gl_pam_hodnoty
	)
      )
    )
  )
)

(princ "\nFunkce se spout pkazem  (c:SObjekty)  v IDE Visual LISPu")
(princ "\nFunkce se spout pkazem  SObjekty v AutoCADu")